#include "QueryBuilder.h"


namespace armarx::armem::client
{

    QueryBuilder::QueryBuilder(DataMode dataMode) : dataMode(dataMode)
    {
    }

    data::query::MemoryQuerySeq QueryBuilder::buildQueries() const
    {
        data::query::MemoryQuerySeq memoryQueries;
        for (const query::CoreSegmentSelector& child : _children)
        {
            for (const data::query::MemoryQueryPtr& query : child.buildQueries())
            {
                memoryQueries.push_back(query);
            }
        }
        return memoryQueries;
    }

    data::QueryInput QueryBuilder::buildQueryInput() const
    {
        data::QueryInput input;
        input.memoryQueries = buildQueries();
        return input;
    }


    query::CoreSegmentSelector& QueryBuilder::coreSegments()
    {
        return _addChild();
    }

    query::CoreSegmentSelector& QueryBuilder::coreSegments(const query::CoreSegmentSelector& selector)
    {
        return _addChild(selector);
    }

}
