#pragma once

#include <RobotAPI/interface/armem/query.h>
#include <RobotAPI/interface/armem/ReadingInterface.h>

#include "query/selectors.h"


namespace armarx::armem::client
{

    enum class DataMode
    {
        NoData,     ///< Just get the structure, but no ARON data.
        WithData,   ///< Get structure and ARON data.
    };


    // ToDo: Make a memory selector (but this level is not in ice, yet)
    /**
     * @brief The QueryBuilder class provides a fluent-style specification of
     * hierarchical queries.
     *
     * Syntax:
     *
     * @code
     * TODO
     * @endcode
     */
    class QueryBuilder :
        public query::detail::ParentSelectorOps<QueryBuilder, query::CoreSegmentSelector>
    {
    public:

        QueryBuilder(DataMode dataMode = DataMode::WithData);


        /// Start specifying core segments.
        query::CoreSegmentSelector& coreSegments();
        query::CoreSegmentSelector& coreSegments(const query::CoreSegmentSelector& selector);


        data::query::MemoryQuerySeq buildQueries() const;
        data::QueryInput buildQueryInput() const;


    public:

        DataMode dataMode;

    };

}
