#include "Commit.h"

#include <SimoxUtility/algorithm/apply.hpp>


namespace armarx::armem
{
    std::ostream& operator<<(std::ostream& os, const EntityUpdateResult rhs)
    {
        return os << "Entity update result: "
               << "\n- success:       \t" << (rhs.success ? "true" : "false")
               << "\n- snapshotID:    \t" << rhs.snapshotID
               << "\n- time arrived:  \t" << rhs.timeArrived.toDateTime()
               << "\n- error message: \t" << rhs.errorMessage
               ;
    }


    bool CommitResult::allSuccess() const
    {
        return std::find_if(results.begin(), results.end(), [](const EntityUpdateResult & r)
        {
            return !r.success;
        }) == results.end();
    }

    std::vector<std::string> CommitResult::allErrorMessages() const
    {
        return simox::alg::apply([](const EntityUpdateResult & res)
        {
            return res.errorMessage;
        }, results);
    }

}
