#pragma once

#include <RobotAPI/interface/armem/query.h>

#include "../memory/Memory.h"
#include "../memory/ice_conversions.h"

#include "BaseQueryProcessor.h"
#include "ProviderSegmentQueryProcessor.h"



namespace armarx::armem
{

    /**
     * @brief Handles memory queries.
     */
    class CoreSegmentQueryProcessor : public BaseQueryProcessor<CoreSegment, data::query::CoreSegmentQuery>
    {
    public:

        CoreSegmentQueryProcessor(DataMode dataMode = DataMode::WithData) :
            BaseQueryProcessor(dataMode), providerSegmentProcessor(dataMode)
        {}


        using BaseQueryProcessor::process;

        void process(CoreSegment& result, const data::query::CoreSegmentQuery& query, const CoreSegment& coreSegment) const;

        void process(CoreSegment& result, const data::query::core::All& query, const CoreSegment& coreSegment) const;
        void process(CoreSegment& result, const data::query::core::Single& query, const CoreSegment& coreSegment) const;
        void process(CoreSegment& result, const data::query::core::Regex& query, const CoreSegment& coreSegment) const;


        data::CoreSegmentPtr processToIce(const data::query::CoreSegmentQuery& query, const CoreSegment& coreSegment) const;


    private:

        ProviderSegmentQueryProcessor providerSegmentProcessor;

    };

}
