#pragma once

#include <RobotAPI/interface/armem/query.h>

#include "../memory/Memory.h"
#include "../memory/ice_conversions.h"

#include "BaseQueryProcessor.h"
#include "CoreSegmentQueryProcessor.h"



namespace armarx::armem
{

    /**
     * @brief Handles memory queries.
     */
    class MemoryQueryProcessor : public BaseQueryProcessor<Memory, data::query::MemoryQuery>
    {
    public:

        MemoryQueryProcessor(DataMode dataMode = DataMode::WithData) :
            BaseQueryProcessor(dataMode), coreSegmentProcessor(dataMode)
        {}


        using BaseQueryProcessor::process;

        data::QueryResult process(const data::QueryInput& input, const Memory& memory) const;


        void process(Memory& result, const data::query::MemoryQuery& query, const Memory& memory) const;

        void process(Memory& result, const data::query::memory::All& query, const Memory& memory) const;
        void process(Memory& result, const data::query::memory::Single& query, const Memory& memory) const;
        void process(Memory& result, const data::query::memory::Regex& query, const Memory& memory) const;


        data::MemoryPtr processToIce(const data::query::MemoryQuery& query, const Memory& memory) const;
        data::MemoryPtr processToIce(const data::query::MemoryQuerySeq& query, const Memory& memory) const;


    private:

        CoreSegmentQueryProcessor coreSegmentProcessor;

    };

}
