#pragma once

#include <RobotAPI/interface/armem/query.h>

#include "../memory/Memory.h"
#include "../memory/ice_conversions.h"

#include "BaseQueryProcessor.h"
#include "EntityQueryProcessor.h"



namespace armarx::armem
{

    /**
     * @brief Handles memory queries.
     */
    class ProviderSegmentQueryProcessor : public BaseQueryProcessor<ProviderSegment, data::query::ProviderSegmentQuery>
    {
    public:

        ProviderSegmentQueryProcessor(DataMode dataMode = DataMode::WithData) :
            BaseQueryProcessor(dataMode), entityProcessor(dataMode)
        {}


        using BaseQueryProcessor::process;

        void process(ProviderSegment& result, const data::query::ProviderSegmentQuery& query, const ProviderSegment& providerSegment) const;

        void process(ProviderSegment& result, const data::query::provider::All& query, const ProviderSegment& providerSegment) const;
        void process(ProviderSegment& result, const data::query::provider::Single& query, const ProviderSegment& providerSegment) const;
        void process(ProviderSegment& result, const data::query::provider::Regex& query, const ProviderSegment& providerSegment) const;


        data::ProviderSegmentPtr processToIce(const data::query::ProviderSegmentQuery& query, const ProviderSegment& providerSegment) const;


    private:

        EntityQueryProcessor entityProcessor;

    };

}
