#pragma once

#include <QTreeWidget>

#include <RobotAPI/libraries/armem/memory/Memory.h>

class QLabel;


namespace armarx::armem
{

    class InstanceTreeWidget : public QTreeWidget
    {
        Q_OBJECT
    public:

        InstanceTreeWidget();

        void update(const MemoryID& id, const Memory& memory);
        void update(const EntityInstance& instance);

        void setStatusLabel(QLabel* statusLabel);


    signals:

        void updated();
        void instanceSelected(const MemoryID& id);


    private slots:


    private:

        void initWidget();

        QLabel* statusLabel = nullptr;


        enum class Columns
        {
            KEY = 0,
            TYPE = 1,
            VALUE = 2,
        };
    };

}
